# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class FundingAgency(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'object',
        'acronym': 'str',
        'creation': 'ChangeInfo',
        'description': 'str',
        'identifiers': 'object',
        'last_update': 'ChangeInfo',
        'name': 'str',
        'res_id': 'str',
        'ror_id': 'str',
        'url': 'str'
    }

    attribute_map = {
        'links': '_links',
        'acronym': 'acronym',
        'creation': 'creation',
        'description': 'description',
        'identifiers': 'identifiers',
        'last_update': 'lastUpdate',
        'name': 'name',
        'res_id': 'resId',
        'ror_id': 'rorId',
        'url': 'url'
    }

    def __init__(self, links=None, acronym=None, creation=None, description=None, identifiers=None, last_update=None, name=None, res_id=None, ror_id=None, url=None, local_vars_configuration=None):  # noqa: E501
        """FundingAgency - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._acronym = None
        self._creation = None
        self._description = None
        self._identifiers = None
        self._last_update = None
        self._name = None
        self._res_id = None
        self._ror_id = None
        self._url = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if acronym is not None:
            self.acronym = acronym
        if creation is not None:
            self.creation = creation
        if description is not None:
            self.description = description
        if identifiers is not None:
            self.identifiers = identifiers
        if last_update is not None:
            self.last_update = last_update
        if name is not None:
            self.name = name
        if res_id is not None:
            self.res_id = res_id
        if ror_id is not None:
            self.ror_id = ror_id
        if url is not None:
            self.url = url

    @property
    def links(self):
        """Gets the links of this FundingAgency.  # noqa: E501

        The _links_ list of the _funding-agencies_ resource  # noqa: E501

        :return: The links of this FundingAgency.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this FundingAgency.

        The _links_ list of the _funding-agencies_ resource  # noqa: E501

        :param links: The links of this FundingAgency.  # noqa: E501
        :type: object
        """

        self._links = links

    @property
    def acronym(self):
        """Gets the acronym of this FundingAgency.  # noqa: E501

        The acronym of the funding agency  # noqa: E501

        :return: The acronym of this FundingAgency.  # noqa: E501
        :rtype: str
        """
        return self._acronym

    @acronym.setter
    def acronym(self, acronym):
        """Sets the acronym of this FundingAgency.

        The acronym of the funding agency  # noqa: E501

        :param acronym: The acronym of this FundingAgency.  # noqa: E501
        :type: str
        """

        self._acronym = acronym

    @property
    def creation(self):
        """Gets the creation of this FundingAgency.  # noqa: E501


        :return: The creation of this FundingAgency.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._creation

    @creation.setter
    def creation(self, creation):
        """Sets the creation of this FundingAgency.


        :param creation: The creation of this FundingAgency.  # noqa: E501
        :type: ChangeInfo
        """

        self._creation = creation

    @property
    def description(self):
        """Gets the description of this FundingAgency.  # noqa: E501

        The description of the funding agency  # noqa: E501

        :return: The description of this FundingAgency.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this FundingAgency.

        The description of the funding agency  # noqa: E501

        :param description: The description of this FundingAgency.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def identifiers(self):
        """Gets the identifiers of this FundingAgency.  # noqa: E501

        The external identifier list of the funding agency  # noqa: E501

        :return: The identifiers of this FundingAgency.  # noqa: E501
        :rtype: object
        """
        return self._identifiers

    @identifiers.setter
    def identifiers(self, identifiers):
        """Sets the identifiers of this FundingAgency.

        The external identifier list of the funding agency  # noqa: E501

        :param identifiers: The identifiers of this FundingAgency.  # noqa: E501
        :type: object
        """

        self._identifiers = identifiers

    @property
    def last_update(self):
        """Gets the last_update of this FundingAgency.  # noqa: E501


        :return: The last_update of this FundingAgency.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """Sets the last_update of this FundingAgency.


        :param last_update: The last_update of this FundingAgency.  # noqa: E501
        :type: ChangeInfo
        """

        self._last_update = last_update

    @property
    def name(self):
        """Gets the name of this FundingAgency.  # noqa: E501

        The name of the funding agency  # noqa: E501

        :return: The name of this FundingAgency.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FundingAgency.

        The name of the funding agency  # noqa: E501

        :param name: The name of this FundingAgency.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def res_id(self):
        """Gets the res_id of this FundingAgency.  # noqa: E501

        The _funding-agencies_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :return: The res_id of this FundingAgency.  # noqa: E501
        :rtype: str
        """
        return self._res_id

    @res_id.setter
    def res_id(self, res_id):
        """Sets the res_id of this FundingAgency.

        The _funding-agencies_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :param res_id: The res_id of this FundingAgency.  # noqa: E501
        :type: str
        """

        self._res_id = res_id

    @property
    def ror_id(self):
        """Gets the ror_id of this FundingAgency.  # noqa: E501

        The ROR identifier of the funding agency  # noqa: E501

        :return: The ror_id of this FundingAgency.  # noqa: E501
        :rtype: str
        """
        return self._ror_id

    @ror_id.setter
    def ror_id(self, ror_id):
        """Sets the ror_id of this FundingAgency.

        The ROR identifier of the funding agency  # noqa: E501

        :param ror_id: The ror_id of this FundingAgency.  # noqa: E501
        :type: str
        """

        self._ror_id = ror_id

    @property
    def url(self):
        """Gets the url of this FundingAgency.  # noqa: E501

        The URL of the funding agency  # noqa: E501

        :return: The url of this FundingAgency.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this FundingAgency.

        The URL of the funding agency  # noqa: E501

        :param url: The url of this FundingAgency.  # noqa: E501
        :type: str
        """

        self._url = url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FundingAgency):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FundingAgency):
            return True

        return self.to_dict() != other.to_dict()
